# Defaults apply to all job definitions
default:
  # Use Docker image "maven" with Maven v3.8.x and JDK 11
  image: maven:3.8-jdk-11
  # Directories to cache and key to identify cache
  cache:
    key: mycachekey
    paths:
      - .m2/repository

# While variables are passed to all jobs definitions, 
# they are not defined within "default" section
variables:
  # MAVEN_OPTS are command line parameters passed via the JVM to Maven
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"  

# Define some compile job to be used as build stage (calls Maven)
mycompile:
  stage: build
  # Execute command "mvn compile -–batch mode"
  script:
    - mvn compile --batch-mode

# Define some unit test job to be used as (unit) test stage (calls Maven)
myunittest:
  # In Gitlab, stage test   # runs after stage build
  stage: test
  # Execute mvn test command
  script:
    - mvn test --batch-mode
